<?php

namespace Teknisa\MAN\Services;

use Doctrine\ORM\EntityManager;
use Teknisa\MAN\Utilities;

class RelDescConcedidosService {
	
	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}
	
	public function getDados($conditions){
		$params = array(
			':CDFILIAL'      => $conditions['CDFILIAL'],
			':TIPORELATORIO' => $conditions['TIPORELATORIO'],
			':TCDFILIAL'     => $conditions['TCDFILIAL'],
			':DTVENDAINI'    => $conditions['DTVENDAINI'],
			':DTVENDAFIN'    => $conditions['DTVENDAFIN']
		);
		
		return $this->entityManager->getConnection()->fetchAll(self::GETDESCONTOS, $params);
	}
	    
	const GETDESCONTOS = "
	SELECT L.CDLOJA, V.DTENTRVENDA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, ( CASE :TIPORELATORIO WHEN 'A' THEN F.CDFILIAL || ' - ' || F.NMFILIAL || ' - Loja: ' || L.CDLOJA || ' - ' || L.NMLOJA WHEN 'S' THEN 'Todas' END ) AS LABELFILIAL, ( CASE :TIPORELATORIO WHEN 'A' THEN L.CDLOJA || ' - ' || L.NMLOJA WHEN 'S' THEN 'Todas' END ) AS LABELLOJA, ( CASE :TIPORELATORIO WHEN 'A' THEN F.CDFILIAL WHEN 'S' THEN 'Todas' END ) AS CDFILIAL, ( CASE :TIPORELATORIO WHEN 'A' THEN F.NMFILIAL WHEN 'S' THEN 'Todas' END ) AS NMFILIAL, ( CASE :TIPORELATORIO WHEN 'A' THEN L.CDLOJA WHEN 'S' THEN 'Todas' END ) AS CODLOJA, ( CASE :TIPORELATORIO WHEN 'A' THEN L.NMLOJA WHEN 'S' THEN 'Todas' END ) AS NMLOJA, NVL(I.CDVENDEDOR, VE.CDVENDEDOR) || ' - ' || VE.NMRAZSOCVEN AS NMRAZSOCVEN, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DATA, V.NRMESA, TO_CHAR(I.DTHRPEDIDO, 'HH24:MI') AS HORAVENDA, I.CDSUPERVDESC AS CDSUPERVISOR, I.CDPRODUTO, I.DSOBSDESCIT, I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL ) AS VRTOTAL, I.VRDESITVEND, TRUNC( (I.VRDESITVEND / CASE WHEN I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL) = 0 THEN 1 ELSE I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL) END ) * 100, 2) AS PORCENTAGEM, I.CDSUPERVDESC, I.CDVENDEDOR, V.CDSUPERVISOR AS CDSUPERVISORVENDA, P.CDPRODUTO || ' - ' || P.NMPRODUTO AS NMPRODUTO, P.CDARVPROD, I.CDSUPERVDESC || ' - ' || P1.NMOPERADOR AS NMOPERADOR, P1.NMOPERADOR AS NMSUPERVISOR FROM FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, GRUPOCOR G, CONSUMIDOR O, OPERADOR P1, OPERADOR P2, OPERADOR P3, VENDEDOR VE WHERE ( ( INSTR(:CDFILIAL, F.CDFILIAL) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) AND ( L.CDFILIAL = F.CDFILIAL ) AND ( V.IDSITUVENDA = 'O' ) AND ( V.DTENTRVENDA BETWEEN TO_DATE(:DTVENDAINI, 'dd/mm/YYYY') AND TO_DATE(:DTVENDAFIN, 'dd/mm/YYYY') ) AND ( V.CDFILIAL = L.CDFILIAL ) AND ( V.CDLOJA = L.CDLOJA ) AND ( I.CDFILIAL = V.CDFILIAL ) AND ( I.CDCAIXA = V.CDCAIXA ) AND ( I.NRSEQVENDA = V.NRSEQVENDA ) AND ( I.CDPRODUTO = P.CDPRODUTO ) AND ( NVL(I.CDGRPOCORDESCIT, V.CDGRPOCORDESC) = G.CDGRPOCOR ) AND ( V.NRORG = L.NRORG ) AND ( V.NRORG = I.NRORG ) AND ( P.NRORG = I.NRORG ) AND ( V.CDCLIENTE = O.CDCLIENTE (+) ) AND ( V.CDCONSUMIDOR = O.CDCONSUMIDOR (+) ) AND ( I.CDSUPERVDESC = P1.CDOPERADOR (+) ) AND ( V.CDOPERADOR = P2.CDOPERADOR (+) ) AND ( I.VRDESITVEND > 0 ) AND ( V.CDSUPERVISOR = P3.CDOPERADOR (+) ) AND ( V.CDVENDEDOR = VE.CDVENDEDOR (+) ) UNION ALL SELECT L.CDLOJA, V.DTENTRVENDA, NVL(V.NRNOTAFISCALCE, V.NRCUPOMFIS) AS CUPOM, ( CASE :TIPORELATORIO WHEN 'A' THEN F.CDFILIAL || ' - ' || F.NMFILIAL || ' - Loja: ' || L.CDLOJA || ' - ' || L.NMLOJA WHEN 'S' THEN 'Todas' END ) AS LABELFILIAL, ( CASE :TIPORELATORIO WHEN 'A' THEN L.CDLOJA || ' - ' || L.NMLOJA WHEN 'S' THEN 'Todas' END ) AS LABELLOJA, ( CASE :TIPORELATORIO WHEN 'A' THEN F.CDFILIAL WHEN 'S' THEN 'Todas' END ) AS CDFILIAL, ( CASE :TIPORELATORIO WHEN 'A' THEN F.NMFILIAL WHEN 'S' THEN 'Todas' END ) AS NMFILIAL, ( CASE :TIPORELATORIO WHEN 'A' THEN L.CDLOJA WHEN 'S' THEN 'Todas' END ) AS CODLOJA, ( CASE :TIPORELATORIO WHEN 'A' THEN L.NMLOJA WHEN 'S' THEN 'Todas' END ) AS NMLOJA, NVL(I.CDVENDEDOR, VE.CDVENDEDOR) || ' - ' || VE.NMRAZSOCVEN AS NMRAZSOCVEN, TO_CHAR(V.DTENTRVENDA, 'DD/MM/YYYY') AS DATA, V.NRMESA, TO_CHAR(I.DTHRPEDIDO, 'HH24:MI') AS HORAVENDA, I.CDSUPERVDESC AS CDSUPERVISOR, I.CDPRODUTO, I.DSOBSDESCIT, I.QTPRODVEND * ( I.VRUNITVEND + I.VRUNITVENDCL ) AS VRTOTAL, I.VRDESITVEND, TRUNC( (I.VRDESITVEND / CASE WHEN I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL) = 0 THEN 1 ELSE I.QTPRODVEND * (I.VRUNITVEND + I.VRUNITVENDCL) END ) * 100, 2) AS PORCENTAGEM, I.CDSUPERVDESC, I.CDVENDEDOR, V.CDSUPERVISOR AS CDSUPERVISORVENDA, P.CDPRODUTO || ' - ' || P.NMPRODUTO AS NMPRODUTO, P.CDARVPROD, I.CDSUPERVDESC || ' - ' || P1.NMOPERADOR AS NMOPERADOR, P1.NMOPERADOR AS NMSUPERVISOR FROM FILIAL F, LOJA L, VENDA V, ITEMVENDA I, PRODUTO P, CONSUMIDOR O, OPERADOR P1, OPERADOR P2, VENDEDOR VE WHERE ( ( INSTR(:CDFILIAL, F.CDFILIAL) <> 0 ) OR ( :TCDFILIAL = 'T' ) ) AND ( L.CDFILIAL = F.CDFILIAL ) AND ( V.IDSITUVENDA = 'O' ) AND ( V.DTENTRVENDA BETWEEN TO_DATE(:DTVENDAINI, 'dd/mm/YYYY') AND TO_DATE(:DTVENDAFIN, 'dd/mm/YYYY') ) AND ( V.CDFILIAL = L.CDFILIAL ) AND ( V.CDLOJA = L.CDLOJA ) AND ( I.CDFILIAL = V.CDFILIAL ) AND ( I.CDCAIXA = V.CDCAIXA ) AND ( I.NRSEQVENDA = V.NRSEQVENDA ) AND ( I.CDPRODUTO = P.CDPRODUTO ) AND ( V.NRORG = L.NRORG ) AND ( V.NRORG = I.NRORG ) AND ( P.NRORG = I.NRORG ) AND ( ( I.CDGRPOCORDESCIT IS NULL ) AND ( V.CDGRPOCORDESC IS NULL ) ) AND ( V.CDCLIENTE = O.CDCLIENTE (+) ) AND ( V.CDCONSUMIDOR = O.CDCONSUMIDOR (+) ) AND ( I.CDSUPERVDESC = P1.CDOPERADOR (+) ) AND ( V.CDOPERADOR = P2.CDOPERADOR (+) ) AND ( I.VRDESITVEND > 0 ) AND ( V.CDVENDEDOR = VE.CDVENDEDOR (+) )
	";
}